/*
 * @author Lenidas de Oliveira Brando
 * Exemplo para desenhos em AWT:
 *  - MenuInferior, MenuSuperior
 *  - desenha em um painel separado do Desenhos
 */

import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;
import java.util.Random; // para gerar valores "aleatrios"

public class Desenhos extends Applet {

  public static int NumObjetos = 10;

  static Point [] pontos = new Point[NumObjetos]; // centros para circunferncias, a serem gerados aleatrios
  static int   [] raios  = new int[NumObjetos];   // raios para circunferncias de centro em "pontos"

  Container JanelaPrincipal; // conter a janela principal, com todas as imagens

  boolean applet = false; // usado para construir corretamente o Applet ou Aplicativo
  boolean frame  = false; // sinaliza que no desejamos abrir um Frame a partir de um "applet"
                          // (neste caso abrimos um Panel dentro do "applet")
  MenuInferior menuInferior;
  MenuSuperior menuSuperior;

  public static Color cor_Msg   = new Color( 64, 128, 198); // (60, 90, 150);//(30, 100, 180);
  public static Color cor_Fundo = new Color(168, 168,   0); //

  static int NumAleatorio   = 100; // para gerar nmero pseudo-aleatrios
  static int RestoAleatorio = 100; // resto da diviso por RestoAleatorio ser considerado
  static int LimInfAleatorio = 50; // constante par adeslocamento do nm. "aleatrio"
  static int DivideAleatorio =  5; // para dividir NumAleatorio e definir raio de crculos

  static Random aleatorio;


  public Desenhos () {
    aleatorio = new Random(NumAleatorio); // 
    NovosCirculos();
    }

  // Inicia quando Aplicativo (antes do construtor)
  public static void main (String[] args) {
    Desenhos desenhos = new Desenhos();
    desenhos.montaJanela();
    }

  // Inicia quando Applet (aps do construtor)
  //  chamado aps o "Applet" ser instanciado
  public void init (){ // sempre que for carregado por applet, entra aqui
    applet = true; // sempre que for carregado por applet, entra aqui
    this.montaJanela(); //  possvel fazer isso em funo do "init()" 
                        // s ser chamado aps criar a instncia da classe principal  
    }

  private void montaJanela () {
    setLayout(new BorderLayout()); // (new FlowLayout());
    menuSuperior = new MenuSuperior();
    menuInferior = new MenuInferior(applet, menuSuperior);

    if (applet && !frame) {
       JanelaPrincipal = this; //
       }
    else
       JanelaPrincipal = new Frame("Desenha objetos - MAC 323 - 2003");

    JanelaPrincipal.add(menuSuperior,"North");
    JanelaPrincipal.add(menuInferior,"South");

    JanelaPrincipal.setSize(400,200);
    JanelaPrincipal.setVisible(true);
    }

  public static void NovosCirculos() {
    for (int i=0; i<Desenhos.NumObjetos; i++) {
        Desenhos.pontos[i] = new Point( aleatorio.nextInt()%RestoAleatorio + LimInfAleatorio, 
                                        aleatorio.nextInt()%RestoAleatorio + LimInfAleatorio );
        Desenhos.raios[i]  = aleatorio.nextInt() % DivideAleatorio + LimInfAleatorio;
        }
    }

  }
